"use strict";

const { NoMatch } = require("../symbols");
const coreOps = require("./index");

module.exports = function* zeroOrMore(instruction, state, context) {
	let { rule } = instruction;

	let matches = [];

	while (true) {
		let reachedEnd = yield coreOps.internalCall.endOfInput({ rule: rule }, state, context);
		// yieldcore.Internal(endOfInput(instruction, state, context), "endOfInput");

		if (reachedEnd === true) {
			break;
		} else {
			let result = yield instruction.rule;

			if (result === NoMatch) {
				break;
			} else {
				matches.push(result);
			}
		}
	}

	return matches;
};
